%if "%{?dist}" == ""
%{warn:You must define dist when building this package, expected values are .fcN, .elN, .slesN\n}
%endif

Name:           dell-hw-specific-repository
Version:        1
Release:        6%{?dist}
Summary:        linux.dell.com Dell system-specific repository configuration
Group:          System Environment/Base
License:        BSD
URL:            http://linux.dell.com
Source:         %{name}.repo
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch:      noarch

Requires: firmware-addon-dell >= 1.2.11
Requires: dell-hw-indep-repository
Obsoletes: dellhw-repository < 3

%description
The Dell linux.dell.com/repo/hardware/ system-specific repository contains
proprietary and open source applications suitable for Dell servers, arranged in
a system of hardware-platform-specific repositories. It may in the future also
be extended to support desktop, notebook and workstation systems.

This package contains the yum-configuration for the
linux.dell.com/repo/hardware repository.

%prep
%build
%install
DIST=%{dist}
# drop leading '.', if present
if [ "${DIST:0:1}" = "." ]; then
    DIST=${DIST:1}
fi

# only supports SLES9/10, and RHEL3/4/5
case "${DIST}" in 
  sles9)
  DIST='sles9'
  ;;
  sles10)
  DIST='sles10'
  ;;
  sles*)
  DIST='sles$releasever'
  ;;
  el4)
  DIST='el4'
  ;;
  el[35])
  DIST='el$releasever'
  ;;
  el*)
  DIST='el$releasever'
  ;;
  *)
  # don't change DIST
  ;;
esac

rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/yum.repos.d/
sed -e "s/\%DIST%/${DIST}/g" %{SOURCE0} > $RPM_BUILD_ROOT%{_sysconfdir}/yum.repos.d/%{name}.repo
chmod 644 $RPM_BUILD_ROOT%{_sysconfdir}/yum.repos.d/%{name}.repo

%clean
rm -rf $RPM_BUILD_ROOT


%files
%defattr(-,root,root,-)
%config(noreplace) %{_sysconfdir}/yum.repos.d/*


%post

# bootstrap script is responsible for laying down /etc/dell-mirror.cfg 
# before we run
HARDWARE_SERVER="http://linux.dell.com"
HARDWARE_REPO_URL="/repo/hardware"
[ -e /etc/dell-mirror.cfg ] && . /etc/dell-mirror.cfg

if [ -e /etc/dell-mirror.cfg ]; then
    FILES="/etc/yum.repos.d/%{name}.repo"
    perl -p -i -e "s|$PUBLIC_HARDWARE_SERVER|$HARDWARE_SERVER|g;" $FILES
    perl -p -i -e "s|$PUBLIC_HARDWARE_REPO_URL|$HARDWARE_REPO_URL|g;" $FILES
fi

# set mirrorlist URL based on repo file.
sys_ven_id=0x1028
sys_dev_id=$(getSystemId | grep "^System ID:"| cut -d: -f2 | xargs echo)
dellsysidpluginver=up2date
FULL_URL=$(grep ^mirrorlist= %{_sysconfdir}/yum.repos.d/%{name}.repo | cut -d= -f2- | perl -p -i -e "s|\\\$sys_ven_id|$sys_ven_id|; s|\\\$sys_dev_id|$sys_dev_id|; s|\\\$dellsysidpluginver|$dellsysidpluginver|;")

# we need to update up2date config here
RHN_SOURCES=/etc/sysconfig/rhn/sources
if [ -e ${RHN_SOURCES} ]; then
  if ! grep -q "^#DONT UPDATE %{name}" ${RHN_SOURCES} > /dev/null 2>&1; then
    # remove existing config
    perl -n -i -e 'print if not /^#BEGIN %{name}/ ... /^#END %{name}/' ${RHN_SOURCES}

    # add updated config unless user specifies not to
    echo "#BEGIN %{name}" >> ${RHN_SOURCES}
    echo "# This block is managed by the %{name} RPM." >> ${RHN_SOURCES}
    echo "" >> ${RHN_SOURCES}
    echo "yum %{name} ${FULL_URL}&redirect=1&redir_path=" >> ${RHN_SOURCES}
    echo "yum-mirror %{name} $FULL_URL" >> ${RHN_SOURCES}
    echo "" >> ${RHN_SOURCES}
    echo "#END %{name}" >> ${RHN_SOURCES}
  fi
fi

# for sles, cannot add rug config here because it crashes zlm.
# have to do it in the bootstrap script

%postun
RHN_SOURCES=/etc/sysconfig/rhn/sources
if [ $1 = 0 ]; then
  # remove up2date config here
  if [ -e $RHN_SOURCES ]; then 
    perl -n -i -e 'print if not /^#BEGIN %{name}/ ... /^#END %{name}/' ${RHN_SOURCES}
  fi
fi	


%changelog
* Wed Jun 20 2007 Michael E Brown <Michael_E_Brown@dell.com> - 1-0
- initial release
